/***************************************************************
Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.		*
								*
This program is free software; you can redistribute it and/or	*
modify it under the terms of the GNU General Public License	*
as published by the Free Software Foundation; either version 2	*
of the License, or (at your option) any later version.		*
								*
This program is distributed in the hope that it will be useful,	*
but WITHOUT ANY WARRANTY; without even the implied warranty of	*
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*
GNU General Public License for more details.			*
								*
You should have received a copy of the GNU General Public License*	
along with this program; if not, write to Prof. D. Janakiram, 	*
DOS Lab, Department of CS & E, Indian Institute of Technology Madras,* 
Chennai - 600036, India. Alternatively, you can send a mail to 	*
d.janakiram@cs.iitm.ernet.in.					*	
*****************************************************************/



#ifndef __DISTPIPEERROR_H__

#define __DISTPIPEERROR_H__ 

#include <errno.h>
extern int errno;

#define SOCKET_CREATION_ERROR -100
#define SOCKET_BIND_ERROR -101
#define SOCKET_ACCEPT_ERROR -102
#define SOCKET_READ_ERROR -103
#define SOCKET_WRITE_ERROR -104
#define SOCKET_CONNECT_ERROR -105
#define SOCKET_GETSOCKNAME_ERROR -106

#define HOST_GETHOSTBYNAME_ERROR -200


#define CREATE_PIPENAME_ALREADY_EXIST 0
#define CREATE_PIPENAME_DONE 1

#define PIPENAME_DOESNOT_EXIST 0
#define PIPENAME_DOES_EXIST 1

#define OPEN_PIPE_WRITE_PENDING 0
#define OPEN_PIPE_WRITE_NOT_PENDING 1

#define CONNECT_READ_WRITE_PIPE_FAILED 0
#define CONNECT_READ_WRITE_PIPE_SUCCEDED 1


#define INVALID_ACCESS_MODE 0
#define READ_ACCESS_MODE 1
#define WRITE_ACCESS_MODE 2


#define USER_ERROR_MESSAGE_PIPENAME_ALREADY_EXIST -300
#define USER_ERROR_MESSAGE_PIPENAME_DOESNOT_EXIST -301

#define XDR_ERROR -401


#define CANNOT_CREATE_FILE -500
#define CANNOT_OPEN_FILE -501
#define CANNOT_READ_FROM_FILE -502
#define CANNOT_WRITE_TO_FILE -503

#ifndef DISTPIPES_LOGMAX
#define DISTPIPES_LOGMAX 65536			
#endif


#define	DISTPIPES_LOGFILE	"/tmp/DistPipes.%d"	


#define STANDARD_ERROR_LOG 1
#define FILE_ERROR_LOG   2


int DistPipeLogError(char* a_pszErrorMessage);
int DistPipeLogSystemError(char* a_pszErrorMessage);
int DistPipeOpenLog();

#endif

