/***************************************************************
Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.		*
								*
This program is free software; you can redistribute it and/or	*
modify it under the terms of the GNU General Public License	*
as published by the Free Software Foundation; either version 2	*
of the License, or (at your option) any later version.		*
								*
This program is distributed in the hope that it will be useful,	*
but WITHOUT ANY WARRANTY; without even the implied warranty of	*
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*
GNU General Public License for more details.			*
								*
You should have received a copy of the GNU General Public License*	
along with this program; if not, write to Prof. D. Janakiram, 	*
DOS Lab, Department of CS & E, Indian Institute of Technology Madras,* 
Chennai - 600036, India. Alternatively, you can send a mail to 	*
d.janakiram@cs.iitm.ernet.in.					*	
*****************************************************************/


#ifndef __HOST_H__

#define __HOST_H__



#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <strings.h>
#include <netdb.h>
#include <signal.h>








typedef struct tagHostDescriptor
{
  
  /* Host Name */
  char* m_pszHostName;
  /* Host Login User Name */
  char* m_pszHostLogin;
  /* path of the daemon that is running */
  char* m_pszDaemonPath;
  
  /* Host Socket details */
  struct sockaddr_in* m_pstTCPHostAddress;
  struct sockaddr_un* m_pstUNIXStreamHostAddress;

  /* Host Architecture */
  int m_nHostArchitecture;
  /* Host Socket descriptor */
  int m_nTCPSocketDescriptor;
  int m_nUNIXStreamSocketDescriptor;
  /* Host Process ID */
  int m_nHostProcessID;
  /* Load */
  unsigned long int m_ulLoad;
  
} HOST_DESCRIPTOR, *PHOST_DESCRIPTOR;



/*
 * Iam implementing as a Array
 * can change the data structure without changing
 * the ohter parts of the code
 */

typedef struct tagHostCollection
{

  struct tagHostCollection* m_pstPrevious;
  HOST_DESCRIPTOR m_stHost;
  struct tagHostCollection* m_pstNext;

} HOST_DESCRIPTOR_COLLECTION, *PHOST_DESCRIPTOR_COLLECTION; 



int InitializeHost(PHOST_DESCRIPTOR a_pstHostDetails, int a_nWhichAddress);
int AddHost(PHOST_DESCRIPTOR a_pstHostDetails);
int DeleteHostFromList(PHOST_DESCRIPTOR_COLLECTION* a_pstListofHosts, PHOST_DESCRIPTOR_COLLECTION a_pstHostNode, int a_nWhichSocket);
int DeleteHost(PHOST_DESCRIPTOR a_pstHostNode, int a_nWhichSocket);

PHOST_DESCRIPTOR_COLLECTION AddNewHost(PHOST_DESCRIPTOR_COLLECTION* a_pstListofHosts);
PHOST_DESCRIPTOR_COLLECTION GetPreviousHost(PHOST_DESCRIPTOR_COLLECTION a_pstListofHosts);
PHOST_DESCRIPTOR_COLLECTION GetNextHost(PHOST_DESCRIPTOR_COLLECTION a_pstListofHosts);


#endif








