/***************************************************************
Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.		*
								*
This program is free software; you can redistribute it and/or	*
modify it under the terms of the GNU General Public License	*
as published by the Free Software Foundation; either version 2	*
of the License, or (at your option) any later version.		*
								*
This program is distributed in the hope that it will be useful,	*
but WITHOUT ANY WARRANTY; without even the implied warranty of	*
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*
GNU General Public License for more details.			*
								*
You should have received a copy of the GNU General Public License*	
along with this program; if not, write to Prof. D. Janakiram, 	*
DOS Lab, Department of CS & E, Indian Institute of Technology Madras,* 
Chennai - 600036, India. Alternatively, you can send a mail to 	*
d.janakiram@cs.iitm.ernet.in.					*	
*****************************************************************/



#ifndef __LOWLEVELROUTINES_H__

#define __LOWLEVELROUTINES_H__


#include "DistPipeHost.h"


int CreateTCPHost(PHOST_DESCRIPTOR a_pstHostDetails);
int BindTCPHost(PHOST_DESCRIPTOR a_pstHostDetails);
int CreateTCPServerHostAndListen(PHOST_DESCRIPTOR a_pstHostDetails, int a_nPortNumber);
int CreateTCPClientHostAndConnect(PHOST_DESCRIPTOR a_pstClientDetails, char* a_pszServerName, int a_nServerPortNumber);

int CreateUNIXStreamHost(PHOST_DESCRIPTOR a_pstHostDetails);
int BindUNIXStreamHost(PHOST_DESCRIPTOR a_pstHostDetails);
int CreateUNIXStreamServerHostAndListen(PHOST_DESCRIPTOR a_pstHostDetails, char* a_pszUNIXStreamPath);
int CreateUNIXStreamClientHostAndConnect(PHOST_DESCRIPTOR a_pstClientDetails, char* a_pszServerPath);

int ListenOnHost(PHOST_DESCRIPTOR a_pstHostDetails, int a_nWhichSocket);
int AcceptOnHost(PHOST_DESCRIPTOR a_pstHostDetails, int a_nWhichSocket);
int ReadOnHost(PHOST_DESCRIPTOR a_pstHostDetails, char* a_pszReadBuffer, int a_nBufferSize, int a_nWhichSocket);
int WriteOnHost(PHOST_DESCRIPTOR a_pstHostDetails, char* a_pszWriteBuffer, int a_nBufferSize, int a_nWhichSocket);
int CloseHost(PHOST_DESCRIPTOR a_pstHostDetails, int a_nWhichSocket);
int CloseSocketDescriptor(int a_nSocketDescriptor);
int AnyDataToReadOnHost(PHOST_DESCRIPTOR a_pstHostDetails, long a_nlSeconds, long a_nlMicroSeconds, int a_nWhichSocket);



int ReadMessageAndData(int a_nMessageID, char* a_pszMessage, PHOST_DESCRIPTOR a_pstHostDetails, int a_nWhichHost);
int WriteMessageAndData(int a_nMessageID, char* a_pszMessage, int a_nMessageSize, PHOST_DESCRIPTOR a_pszHostDetails, int a_nWhichHost);

int GetHostPortAddress(PHOST_DESCRIPTOR a_pstHostDetails, int a_nWhichSocket);


int WriteToSocketDescriptor(int a_nSocketDescriptor, char* a_pszWriteBuffer, int a_nBufferSize);
int ReadFromSocketDescriptor(int a_nSocketDescriptor, char* a_pszReadBuffer, int a_nBufferSize);


#endif
