/***************************************************************
Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.		*
								*
This program is free software; you can redistribute it and/or	*
modify it under the terms of the GNU General Public License	*
as published by the Free Software Foundation; either version 2	*
of the License, or (at your option) any later version.		*
								*
This program is distributed in the hope that it will be useful,	*
but WITHOUT ANY WARRANTY; without even the implied warranty of	*
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*
GNU General Public License for more details.			*
								*
You should have received a copy of the GNU General Public License*	
along with this program; if not, write to Prof. D. Janakiram, 	*
DOS Lab, Department of CS & E, Indian Institute of Technology Madras,* 
Chennai - 600036, India. Alternatively, you can send a mail to 	*
d.janakiram@cs.iitm.ernet.in.					*	
*****************************************************************/



#ifndef __DISTPIPETABLE_H__


#define __DISTPIPETABLE_H__

#include "DistPipeHost.h"

/*** Stucture for the DistPipeTable ***/

typedef struct {

  /* Create Pipe Details */
  char* m_pszCreateMachineName;
  char* m_pszPipeName;

  /* Read Pipe Details */
  char* m_pszReadMachineName;
  int m_nReadPortNumber;
  int m_nReadSocketDescriptor;
  int m_nReadProcessId;

  /* Write Pipe Details */
  char* m_pszWriteMachineName;
  int m_nWritePortNumber;
  int m_nWriteSocketDescriptor;
  int m_nWriteProcessId;
  
  /* For System Coordinator to find out the status of read 
   * and write entry details of the strucutre */
  int m_nReadEntryValid;
  int m_nWritePending;
  
  /* This pointer is used only by system coordinator 
   * on WritePending is set */
  PHOST_DESCRIPTOR_COLLECTION m_pstLCWritePending;


} DIST_PIPE_ENTRY, *PDIST_PIPE_ENTRY;


typedef struct tagDistributedPipeTable
{

  DIST_PIPE_ENTRY m_stDistPipeEntry;
  struct tagDistributedPipeTable* m_pstNext;

} DIST_PIPE_TABLE, *PDIST_PIPE_TABLE;


PDIST_PIPE_TABLE IfPipeExists(PDIST_PIPE_TABLE a_pstDistPipeTable, char* a_pszPipeName);
int AppendTable(PDIST_PIPE_TABLE* a_pstDistPipeTable, char* a_pszCreateMachineName, char* a_pszPipeName);
int DeleteEntry(PDIST_PIPE_TABLE* a_pstDistPipeTable, char* a_pszPipeName);
int UpdateEntry(PDIST_PIPE_TABLE a_pstDistPipeTable, char* a_pszPipeName, int a_nAccessMode, char* a_nMachineName, int a_nPortNo, int a_nProcessId, int a_nSocketDescriptor);
int PrintTable(PDIST_PIPE_TABLE a_pstDistPipeTable);
int PrintFullTable(PDIST_PIPE_TABLE a_pstDistPipeTable);
int DeleteTable(PDIST_PIPE_TABLE a_pstDistPipeTable);

PDIST_PIPE_TABLE GetDistPipeDetails(PDIST_PIPE_TABLE* a_pstDistPipeTable, char* a_pszPipeName);

#endif
