/***************************************************************
Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.		*
								*
This program is free software; you can redistribute it and/or	*
modify it under the terms of the GNU General Public License	*
as published by the Free Software Foundation; either version 2	*
of the License, or (at your option) any later version.		*
								*
This program is distributed in the hope that it will be useful,	*
but WITHOUT ANY WARRANTY; without even the implied warranty of	*
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*
GNU General Public License for more details.			*
								*
You should have received a copy of the GNU General Public License*	
along with this program; if not, write to Prof. D. Janakiram, 	*
DOS Lab, Department of CS & E, Indian Institute of Technology Madras,* 
Chennai - 600036, India. Alternatively, you can send a mail to 	*
d.janakiram@cs.iitm.ernet.in.					*	
*****************************************************************/
#include <stdio.h>
#include <unistd.h>

#include "SteadyState.h"

#define PIPENAME_LENGTH 256
#define HOSTNAME_LENGTH 256
#define PATH_LENGTH 256

int main()
{

  int l_nWorkID;
  int l_nNumberofSplits;
  int l_nSplitIndex;
  int l_nMatrixRows = 10;
  int l_nMatrixColumns = 90;
  int l_nStartRow;
  int l_nNumberofRows;
  int l_nDataPacketSize;

  char l_szResultPipe[PIPENAME_LENGTH];
  char l_szMigrateFile[PATH_LENGTH];
  char* l_pszDataPacket;
  

  strcpy(l_szMigrateFile, "Mig.c");

  /* intialize the the steady state probelm */
  if ((l_nWorkID = IntializeSteadyStateProblem()) < 0)
    {
      return -1;
    }

  /*Send the Maximum Number of Rows and Columns of the matrix */
  if (SendMatrixInformation(l_nWorkID, l_nMatrixRows, l_nMatrixColumns) < 0)
    {
      return -1;
    }
  
  
  if ((l_nNumberofSplits = ObtainNumberOfSplits(l_nWorkID)) <= 0)
    {
      return -1;
    }
	printf("Number of Splits is : %d\n", l_nNumberofSplits);

  for(l_nSplitIndex = 0; l_nSplitIndex < l_nNumberofSplits; l_nSplitIndex++)
    {
      ObtainSplitInformation(l_nWorkID, l_nSplitIndex, &l_nStartRow, &l_nNumberofRows);

      printf("Split Index %d : start row is %d, and number of rows is %d\n\n",
              l_nSplitIndex, l_nStartRow, l_nNumberofRows);


/*       l_pstDataPacket = MakeDataPacket(l_pstMatrix, l_nStartRow, l_nNumberofRows); */
/*        l_nDataPacketSize = l_nStartRow * l_nNumberofRows * sizeof(float);  */


       /* Create the result pipe name */
       gethostname(l_szResultPipe, HOSTNAME_LENGTH);
       sprintf(l_szResultPipe, "_Res_%d_%d", l_nWorkID, l_nSplitIndex);


       /* create the result pipe name */
       if (CreateDistPipe(l_szResultPipe) < 0) 
 	 { 
 	   /*WorkOver(l_nWorkID);*/ 
        printf("Error creating result pipe : l_szResultPipe\n"); 
 	   return -1; 
 	 }

      //  printf("Make change! or else I'll coredump!!\n");
        //printf("I'm gonna send data packet containing : %s\n", l_pszDataPacket); // coredump .. obviously 
       if (SendWorkAndExecute(l_nWorkID, l_nSplitIndex, l_szMigrateFile, l_pszDataPacket, l_nDataPacketSize, l_szResultPipe) < 0) 
 	{
 	  printf("Sample Parsed Code cupped!\n");
      return -1; 
 	} 
    }
    printf("SampleParsedCode succeeded!\n");
return 1;
}
