/***************************************************************
Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.		*
								*
This program is free software; you can redistribute it and/or	*
modify it under the terms of the GNU General Public License	*
as published by the Free Software Foundation; either version 2	*
of the License, or (at your option) any later version.		*
								*
This program is distributed in the hope that it will be useful,	*
but WITHOUT ANY WARRANTY; without even the implied warranty of	*
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*
GNU General Public License for more details.			*
								*
You should have received a copy of the GNU General Public License*	
along with this program; if not, write to Prof. D. Janakiram, 	*
DOS Lab, Department of CS & E, Indian Institute of Technology Madras,* 
Chennai - 600036, India. Alternatively, you can send a mail to 	*
d.janakiram@cs.iitm.ernet.in.					*	
*****************************************************************/


#ifndef __WORK_H__

#define __WORK_H__

#include "DistPipeHost.h"
#include "DistPipeMesg.h"

typedef struct
{

  int m_nStarting;
  int m_nTotal;
  PHOST_DESCRIPTOR m_pstSplitHostDetail;
  unsigned long int m_ulLoad;

} SPLIT_INFORMATION, *PSPLIT_INFORMATION;


typedef struct 
{

  char m_szMigrateFileName[PATH_LENGTH];
  int m_nWorkID;
  int m_nNumberOfSplits;
  int m_nMaximumRows;
  int m_nMaximumColumns;
  PSPLIT_INFORMATION m_pstSplitInformation;

} WORK_INFORMATION, *PWORK_INFORMATION;


typedef struct tagLinkListWorkDetails
{
  PWORK_INFORMATION m_pstWorkDetail;
  struct tagLinkListWorkDetails* m_pstNext;
} WORK_INFORMATION_COLLECTION, *PWORK_INFORMATION_COLLECTION;




int AddSplitInformation(PWORK_INFORMATION_COLLECTION* a_pstWorkCollection, int a_nWorkID);
int DeleteSplitInformation(PWORK_INFORMATION_COLLECTION* a_pstWorkCollection, int a_nWorkID);
int DeleteAllSplitInformation(PWORK_INFORMATION_COLLECTION* a_pstWorkCollection);
PWORK_INFORMATION_COLLECTION FindWork(PWORK_INFORMATION_COLLECTION a_pstWorkCollection, int a_nWorkID);
int SetNumberOfSplitInformation(PWORK_INFORMATION_COLLECTION a_pstWork, int a_nNumberOfSplits);
int SetSplitInformation(PWORK_INFORMATION_COLLECTION a_pstWork, int a_nSplitID, PHOST_DESCRIPTOR a_pstHostDetail, int a_nStart, int a_nTotal);
int UpdateMigrateFile(PWORK_INFORMATION_COLLECTION a_pstWork, char* a_pszFileName);
int UpdateRowColumnForWork(PWORK_INFORMATION_COLLECTION a_pstWork, int a_nRows, int a_nColumns);
int FindStartAndNumberOfRowsForSplit(PWORK_INFORMATION_COLLECTION a_pstWork, int a_nSplitID, int* a_pnStart, int* a_pnTotal);


#endif




