/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <fstream.h>

class ClientFilter {
        private:
		int argc;
		CORBA::Long result;
		char *Address;
		char *argv[10];
                CORBA::ORB_var orb;
                CORBA::BOA_var boa;
                CORBA::Object_ptr Obj;
                Cool_var ServerReference;
        public:
                ClientFilter(char *temp){
		// nothing to do.
			argc = 3;
			Address = new char[20];
			strcpy(Address, temp);
			argv[0] = new char[20];
                        argv[1] = new char[20];
                        argv[2] = new char[20];
			//cout << "in constructor of filter" << endl;
                        strcpy(argv[0],"CoolClient");
                        strcpy(argv[1],"-ORBBindAddr");

			strcpy(argv[2],temp);
			orb = CORBA::ORB_init(argc, argv, "mico-local-orb");	
			//cout << "in constructor of filter, after orb" << endl;
			if  (CORBA::is_nil (orb) ){
                                cout << "exception in the code, orb problem" <<
endl;
                                cout << "no such object " << endl;
                        }

        	}
		CORBA::Long RunKilometer(CORBA::ULong x) {
			//cout << "in client side filter " << endl;
			 try {
				Obj = orb -> bind("IDL:Cool:1.0",Address);
                                ServerReference = Cool::_narrow(Obj);
				if  (CORBA::is_nil (Obj) ){
                                	cout << "exception in the client code" << endl;
                                	cout << "no such object " << endl;
                                	return 0;
                        	}

                                result = ServerReference -> RunKilometer(x);

        		}
		 	catch (RebindException r) {
                		cout <<"rebinding to the new address  " <<r.NewAddress << endl;
                		Obj = orb -> bind("IDL:Cool:1.0",r.NewAddress);
                		ServerReference = Cool::_narrow(Obj);
				if  (CORBA::is_nil (Obj) ){
                                	cout << "exception in the client code" << endl;
                                	cout << "no such object " << endl;
                                	return 0;
                        	}

                		result = ServerReference -> RunKilometer(x);
        		}
			return result;
		}
		void Compute(double StartValue, double EndValue) {
			//cout << "in client side filter " << endl;
			 try {
				Obj = orb -> bind("IDL:Cool:1.0",Address);
                                ServerReference = Cool::_narrow(Obj);
				if  (CORBA::is_nil (Obj) ){
                                	cout << "exception in the client code" << endl;
                                	cout << "no such object " << endl;
                                	return;
                        	}

				ServerReference->Compute(StartValue, EndValue);
        		}
		 	catch (RebindException r) {
                		cout <<"rebinding to the new address  " <<r.NewAddress << endl;
                		Obj = orb -> bind("IDL:Cool:1.0",r.NewAddress);
                		ServerReference = Cool::_narrow(Obj);
				if  (CORBA::is_nil (Obj) ){
                                	cout << "exception in the client code" << endl;
                                	cout << "no such object " << endl;
                                	return;
                        	}
				ServerReference->Compute(StartValue, EndValue);
        		}
			catch (const CORBA::TRANSIENT &) {
				sleep(1);// object in motion, wait.
				cout <<"*****object in motion, waiting"<< endl;
				ServerReference->Compute(StartValue, EndValue);
			}
			return;
		}
		void ExchangeBoundaryValues() {
                        cout << "in client side filter " << endl;
                         try {
                                Obj = orb -> bind("IDL:Cool:1.0",Address);
                                ServerReference = Cool::_narrow(Obj);
                                if  (CORBA::is_nil (Obj) ){
                                        cout << "exception in the client code" << endl;
                                        cout << "no such object " << endl;
                                        return;
                                }
                                ServerReference->ExchangeBoundaryValues();
                        }
			catch (RebindException r) {
                                cout <<"rebinding to the new address  " <<r.NewAddress << endl;
                                Obj = orb -> bind("IDL:Cool:1.0",r.NewAddress);
                                ServerReference = Cool::_narrow(Obj);
                                if  (CORBA::is_nil (Obj) ){
                                        cout << "exception in the client code" << endl;
                                        cout << "no such object " << endl;
                                        return;
                                }
                                ServerReference->ExchangeBoundaryValues();
                        }
                        return;
                }
};
