/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <fstream.h>
#include "LookUp.cc"
#include "Cool.h"

class Filter {
        private:
		CORBA::ORB_var orb;
		CORBA::BOA_var boa;
		CORBA::Object_var Obj;
		Cool_var ServerReference;
		int ObjectInMotion;
        public:
		Filter(){
			ObjectInMotion = 0;
	}		
		void Update(char *Address) {
			char *temp = new char[20];
			
			ObjectInMotion = 0;			

			/* FILE *fp;
			fp = fopen("LocationFile","r+");
			if ( !fp ) {
				cout << "cant open file " << endl;
			}
			fread(temp, 20, 1, fp);  
			cout << " read "<< temp << endl; */
			
			ofstream out("LocationFile");
			if ( !out ) {
				cout << "cant open file"<< endl;
				return;
			}
			/* inout >> temp;
			//cout << "in filter and location is "<< temp << endl; */
			//cout << " the new address is " << Address<< endl;
			/* inut << "\n";
			inout << Address; */
			out.write((char*)Address,strlen(Address));	
			//out.write((char*)"\n",20);
			return;
		}
                long RunKilometer(long InParam) {
			if (ObjectInMotion == 1) {
			// object is in motion.
				throw CORBA::TRANSIENT();
				//return 0;
			}
			char *Address = new char [30];
			Address = LookUp();
			//cout << "in run of the filter object " << endl;
			char *argv[5];
			int argc;
			argv[0] = new char[20];
			argv[1] = new char[20];
			argv[2] = new char[20];
			//cout << "After 1st allocation" << endl;
			/* argv[1] = (char*)malloc(10*sizeof(char));
			argv[2] = (char*)malloc(10*sizeof(char)); */
			strcpy(argv[0],"CoolClient");
			strcpy(argv[1],"-ORBBindAddr");
			strcpy(argv[2],Address);
			argc = 3;
			//cout << " just before binding " << argv[0] << argv[1] << argv[2] << endl;
        		orb = CORBA::ORB_init(argc, argv, "mico-local-orb");
			if  (CORBA::is_nil (orb) ){
                                cout << "exception in the code, orb problem" << endl;
                                cout << "no such object " << endl;
                                return 0;
                        }

			//cout << " just after orb" << endl;
			Obj = orb -> bind("IDL:Cool:1.0",Address);
			//cout << " just after successful binding " << endl;
        		ServerReference = Cool::_narrow(Obj);
			if  (CORBA::is_nil (Obj) ){
        	                cout << "exception in the client code" << endl;
                	        cout << "no such object " << endl;
                        	return 0;
	                }

			long result;
                        if (InParam == 0) {
                                return 0;
                        }
                        else {
				cout << "In filter and param is " << InParam << endl;
				result = ServerReference->RunKilometer(InParam);
                                return result;
                        }
                }
                void Compute(const GraphTour Tour) {
			if (ObjectInMotion == 1) {
			// object is in motion.
				cout <<"***** object in motion, client cant connect "<< endl;
				throw CORBA::TRANSIENT();
				//return;
			}
			char *Address = new char [30];
			Address = LookUp();
			//cout << "in run of the filter object " << endl;
			char *argv[5];
			int argc;
			argv[0] = new char[20];
			argv[1] = new char[20];
			argv[2] = new char[20];
			//cout << "After 1st allocation" << endl;
			/* argv[1] = (char*)malloc(10*sizeof(char));
			argv[2] = (char*)malloc(10*sizeof(char)); */
			strcpy(argv[0],"CoolClient");
			strcpy(argv[1],"-ORBBindAddr");
			strcpy(argv[2],Address);
			argc = 3;
			//cout << " just before binding " << argv[0] << argv[1] << argv[2] << endl;
        		orb = CORBA::ORB_init(argc, argv, "mico-local-orb");
			if  (CORBA::is_nil (orb) ){
                                cout << "exception in the code, orb problem" << endl;
                                cout << "no such object " << endl;
                                return;
                        }

			//cout << " just after orb" << endl;
			Obj = orb -> bind("IDL:Cool:1.0",Address);
			//cout << " just after successful binding " << endl;
        		ServerReference = Cool::_narrow(Obj);
			if  (CORBA::is_nil (Obj) ){
        	                cout << "exception in the client code" << endl;
                	        cout << "no such object " << endl;
                        	return;
	                }
			ServerReference->Compute(Tour);

                }
                void ExchangeBoundaryValues() {
			if (ObjectInMotion != 1) {
			// object not in motion.
				throw CORBA::TRANSIENT();
				return;
			}
			char *Address = new char [30];
			Address = LookUp();
			//cout << "in run of the filter object " << endl;
			char *argv[5];
			int argc;
			argv[0] = new char[20];
			argv[1] = new char[20];
			argv[2] = new char[20];
			//cout << "After 1st allocation" << endl;
			/* argv[1] = (char*)malloc(10*sizeof(char));
			argv[2] = (char*)malloc(10*sizeof(char)); */
			strcpy(argv[0],"CoolClient");
			strcpy(argv[1],"-ORBBindAddr");
			strcpy(argv[2],Address);
			argc = 3;
        		orb = CORBA::ORB_init(argc, argv, "mico-local-orb");
			if  (CORBA::is_nil (orb) ){
                                cout << "exception in the code, orb problem" << endl;
                                cout << "no such object " << endl;
                                return;
                        }

			Obj = orb -> bind("IDL:Cool:1.0",Address);
        		ServerReference = Cool::_narrow(Obj);
			if  (CORBA::is_nil (Obj) ){
        	                cout << "exception in the client code" << endl;
                	        cout << "no such object " << endl;
                        	return;
	                }
			ServerReference->ExchangeBoundaryValues();

                }
		void Attach() {
                        cout << " about to attach filter " << endl;
                        ObjectInMotion = 1;
                        // indicates object is moving, clients cant access it.
                }

};

