/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__KERNEL_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __KERNEL_H__

#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif

struct S;
typedef TVarVar<S> S_var;
typedef S_var S_out;

struct S {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef S_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  S();
  ~S();
  S( const S& s );
  S& operator=( const S& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  CORBA::String_var str;
};

typedef S S1;
#ifdef _WINDOWS
static S1 _dummy_S1;
#endif
typedef S_var S1_var;
typedef S1_var S1_out;

typedef CORBA::Long List[ 3 ];
typedef CORBA::Long List_slice;
typedef ArrayFixVar<CORBA::Long,List_slice,List,3> List_var;
typedef List_var List_out;
enum _dummy_List { _dummy_List_0 };
typedef ArrayFixForAny<CORBA::Long,List_slice,List,3,_dummy_List> List_forany;
#undef MICO_ARRAY_ARG
#define MICO_ARRAY_ARG CORBA::Long
DECLARE_ARRAY_ALLOC(List,MICO_ARRAY_ARG,List_slice,3)
DECLARE_ARRAY_DUP(List,MICO_ARRAY_ARG,List_slice,3)
DECLARE_ARRAY_FREE(List,MICO_ARRAY_ARG,List_slice,3)
DECLARE_ARRAY_COPY(List,MICO_ARRAY_ARG,List_slice,3)
class Kernel;
typedef Kernel *Kernel_ptr;
typedef Kernel_ptr KernelRef;
typedef ObjVar<Kernel> Kernel_var;
typedef Kernel_var Kernel_out;


// Common definitions for interface Kernel
class Kernel : 
  virtual public CORBA::Object
{
  public:
    virtual ~Kernel();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef Kernel_ptr _ptr_type;
    typedef Kernel_var _var_type;
    #endif

    static Kernel_ptr _narrow( CORBA::Object_ptr obj );
    static Kernel_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static Kernel_ptr _duplicate( Kernel_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static Kernel_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual void GetMachinesList( List L1 ) = 0;
    virtual void GetLocalLoadCondition( CORBA::Double& Bool ) = 0;

  protected:
    Kernel() {};
  private:
    Kernel( const Kernel& );
    void operator=( const Kernel& );
};

// Stub for interface Kernel
class Kernel_stub:
  virtual public Kernel
{
  public:
    virtual ~Kernel_stub();
    void GetMachinesList( List L1 );
    void GetLocalLoadCondition( CORBA::Double& Bool );

  private:
    void operator=( const Kernel_stub& );
};

#ifndef MICO_CONF_NO_POA

class Kernel_stub_clp :
  virtual public Kernel_stub,
  virtual public PortableServer::StubBase
{
  public:
    Kernel_stub_clp (PortableServer::POA_ptr, CORBA::Object_ptr);
    virtual ~Kernel_stub_clp ();
    void GetMachinesList( List L1 );
    void GetLocalLoadCondition( CORBA::Double& Bool );

  protected:
    Kernel_stub_clp ();
  private:
    void operator=( const Kernel_stub_clp & );
};

#endif // MICO_CONF_NO_POA

#ifndef MICO_CONF_NO_POA

class POA_Kernel : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~POA_Kernel ();
    Kernel_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static POA_Kernel * _narrow (PortableServer::Servant);
    virtual CORBA::Object_ptr _make_stub (PortableServer::POA_ptr, CORBA::Object_ptr);

    virtual void GetMachinesList( List L1 ) = 0;
    virtual void GetLocalLoadCondition( CORBA::Double& Bool ) = 0;

  protected:
    POA_Kernel () {};

  private:
    POA_Kernel (const POA_Kernel &);
    void operator= (const POA_Kernel &);
};

template<class T>
class POA_Kernel_tie : 
  virtual public POA_Tie_Base<T>,
  virtual public POA_Kernel
{
  public:
    POA_Kernel_tie (T &t)
      : POA_Tie_Base<T> (&t, PortableServer::POA::_nil(), FALSE)
    {}
    POA_Kernel_tie (T &t, PortableServer::POA_ptr _poa)
      : POA_Tie_Base<T> (&t, _poa, FALSE)
    {}
    POA_Kernel_tie (T *t, CORBA::Boolean _rel = TRUE)
      : POA_Tie_Base<T> (t, PortableServer::POA::_nil(), _rel)
    {}
    POA_Kernel_tie (T *t, PortableServer::POA_ptr _poa, CORBA::Boolean _rel = TRUE)
      : POA_Tie_Base<T> (t, _poa, _rel)
    {}
    virtual ~POA_Kernel_tie ();

    PortableServer::POA_ptr _default_POA ();

    void GetMachinesList( List L1 );
    void GetLocalLoadCondition( CORBA::Double& Bool );

  protected:
    POA_Kernel_tie () {};

  private:
    POA_Kernel_tie (const POA_Kernel_tie<T> &);
    void operator= (const POA_Kernel_tie<T> &);
};

template<class T>
POA_Kernel_tie<T>::~POA_Kernel_tie ()
{
}

template<class T>
PortableServer::POA_ptr
POA_Kernel_tie<T>::_default_POA ()
{
  if (!CORBA::is_nil (POA_Tie_Base<T>::poa)) {
    return PortableServer::POA::_duplicate (POA_Tie_Base<T>::poa);
  }
  return PortableServer::ServantBase::_default_POA ();
}

template<class T>
void
POA_Kernel_tie<T>::GetMachinesList (List L1)
{
  POA_Tie_Base<T>::ptr->GetMachinesList (L1);
}

template<class T>
void
POA_Kernel_tie<T>::GetLocalLoadCondition (CORBA::Double& Bool)
{
  POA_Tie_Base<T>::ptr->GetLocalLoadCondition (Bool);
}

#endif // MICO_CONF_NO_POA

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

extern CORBA::StaticTypeInfo *_marshaller_S;

extern CORBA::StaticTypeInfo *_marshaller_Kernel;

extern CORBA::StaticTypeInfo *_marshaller__a3_long;

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#if !defined(MICO_NO_TOPLEVEL_MODULES) && !defined(MICO_IN_GENERATED_CODE)
#include <mico/template_impl.h>
#endif

#endif
