/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include "Kernel.h"
#include "Kernel.cc"
#include <sys/time.h>
#define M 3

int main(int argc, char *argv[]) {

	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv, "mico-local-orb");
	int i;
	CORBA::Object_var obj = orb->bind("IDL:Kernel:1.0", argv[1]);
	Kernel_var ClientRef = Kernel::_narrow(obj);
	if (CORBA::is_nil(ClientRef) ) {
		printf("oops : Reference is nil\n");
		exit(1);
	}
	List MachinesList;

	int ReturnValueTime;
        struct timeval tvBefore, tvAfter;
        ReturnValueTime = gettimeofday(&tvBefore, (struct timezone*)0);
        if ( ReturnValueTime == -1 ) {
                cout << " gettime of day cribbed  " << endl;
                return;
        }


	ClientRef->GetMachinesList(MachinesList);
	
	 ReturnValueTime = gettimeofday(&tvAfter, (struct timezone*)0);
        if ( ReturnValueTime == -1 ) {
                 cout << " gettime of day cribbed  " << endl;
                 return;
        }
        long diff = (tvAfter.tv_sec - tvBefore.tv_sec)*1000 + (tvAfter.tv_usec - tvBefore.tv_usec)/1000;
        cout << "overhead is " << diff<< " millisecs"<< endl;


	for(i=0;i<M;i++){
		cout << MachinesList[i] << " " ;
	}
	cout << endl;
	/* struct S *s1;
	s1 = new struct S; */
	CORBA::Double &Bool = 0;
	// ClientRef->GetLocalLoadCondition(Bool);
	//cout << "the machine usage status is " << Bool<< endl;
}
