/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include "Kernel.h"
#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <stdlib.h>

#define M 3

class Kernel_impl : virtual public POA_Kernel {
private:
	int i;
	List MachinesList;
	List ProcessingSpeed;
	char *MachineNames[M];
public:
	Kernel_impl() {
		for(i=0;i<M;i++) {
			MachinesList[i] = 0;
			MachineNames[i] = new char[30];
			// 0 indicates that m/c cant be used
		}
		ProcessingSpeed[0] = 166; // Mhz
		ProcessingSpeed[1] = 200; // Mhz
		ProcessingSpeed[2] = 233; // Mhz
		
		cout << "initialization okay " << endl;	
		strcpy(MachineNames[0],"inet:malli:9900");
		strcpy(MachineNames[1],"inet:lotus:9900");
		strcpy(MachineNames[2],"inet:jasmine:9900");
	}
	void GetMachinesList(List ListToBeReturned) {
		for(i=0;i<M;i++) {
			ListToBeReturned[i] = 0;
		}
		char *argv[5];
		double LoadValue;
		double LoadFactor;
                int argc;
                argv[0] = new char[20];
                argv[1] = new char[20];
                argv[2] = new char[20];
                cout << "After 1st allocation" << endl;
                strcpy(argv[0],"KernelClient");
                strcpy(argv[1],"-ORBBindAddr");
                strcpy(argv[2],"");
                argc = 3;

		CORBA::ORB_var orb = CORBA::ORB_init(argc, argv, "mico-local-orb");	
		CORBA::Object_var obj[M];
		Kernel_var ClientRef[M];
		for(i=0;i<M;i++) {
			obj[i] = orb -> bind("IDL:Kernel:1.0",MachineNames[i]);
			ClientRef[i] = Kernel::_narrow(obj[i]);
			if ( CORBA::is_nil(ClientRef[i]) ) {
				printf("oops : Reference is nil \n");
				exit(1);
			}
			ClientRef[i]->GetLocalLoadCondition(LoadValue);
			LoadFactor = LoadValue/ProcessingSpeed[i];
			if (LoadFactor < 0.012) {
				ListToBeReturned[i] = 1;
			}
		}
		cout << "list of machines about to be returned" << endl;
	}
	void GetLocalLoadCondition(CORBA::Double &Bool) {
		system("uptime > c");
		char *value, *dump;
		FILE *fp;
		fp = fopen("c","r");
		value = new char [6];
		dump = new char [60];
		dump = fgets(dump, 58, fp);
		value = fgets(value, 5, fp); 
		cout << dump << endl;
		cout << " this is what is required " << endl;
		cout << value << endl;
		Bool = atof(value);
		cout << "this is the value " << Bool <<endl;
		fclose(fp);
		/* ifstream in;
		in.open("c");
		for(i=0;!(in);i++) {
			value[i] = new char[10];
			in >> value[i];
		}
		for(i=0;i<30;i++) {
			cout << i <<"th value is " << value[i] << endl;
		}*/
		cout << "all right, about to return " << endl;
		//return s;
	}
};	

