/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include "matrix.h"
#include "matrix.cc"
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>
#define Dimension 500
#define MAX_DIM 500

long ResultArray[MAX_DIM][MAX_DIM];

int Handler(CORBA::Request_ptr req, int Number) {
	int i, j;
	long LocalResultArray[MAX_DIM][MAX_DIM];
        CORBA::Any a ;
        CORBA::Long result;
        CORBA::Long ReturnValue;
        int flag = 0;
		req->send_deferred();
                req->get_response();
                if ( req->env()->exception() == 0 ) {
                        a = req->return_value() ;
                        a >>= ReturnValue;
                        //cout << "no exception and returned " << ReturnValue <<
 endl;
                }
                else {
                        //cout << " exception thrown  " << endl;
                        //cout << "returned from the method " << result << endl;
                }
                while (flag == 0) {
                        if ( req->poll_response() == FALSE ) {
                                cout << " not yet returned from the server " <<
endl;
                        }

	               else {
                                //cout << " returned from the server " << endl;
                                //cout << "result is   " << result << endl;
                                flag = 1;
                                //cout << " have finshed 2 invocation " << endl;

                        }
                }
	/* req->add_out_arg("Multiply") >>= LocalResultArray;
	for (i=0;i<Dimension;i++) {
		for (j=0;j<Dimension;j++) {
			cout << LocalResultArray[i][j] << " " ;
			ResultArray[i][j] += LocalResultArray[i][j]; 
		}
		cout << endl;
	} */
        return Number;
} /* end of function */




int main(int argc, char *argv[]) {
      	int i,j = 0, k, p, q;
	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv, "mico-local-orb");
	int NoOfMachines = argc;
     	argumenttype Input[NoOfMachines]; 
	srand(900);
	for (i=0;i<Dimension;i++) {
		for (j=0;j<Dimension;j++) {
			ResultArray[i][j] = 0;
		}
	}
	for(k=0;k<NoOfMachines;k++) {
		Input[k].dim = Dimension;
  		for(i=0;i<Dimension;i++){
    			for(j=0;j<Dimension;j++){
      				Input[k].a[i][j] = 0;
     			 	Input[k].b[i][j] = rand() % 10;  
				/* to ensure a number between 0 and 9 */
    			}
  		}
	}
	for(k=0;k<NoOfMachines;k++) 
  	for(i=0;i<Input[k].dim;i++)
    		Input[k].a[i][i] = 1;
	
	// partition the array
	int remainder = Dimension % NoOfMachines;
	int value = Dimension/NoOfMachines;
	int initializer = 0;
	for(i=0;i<NoOfMachines;i++) {
		Input[i].startRow = initializer;
		Input[i].endRow = initializer + value - 1;
		initializer +=value;
	}
	Input[NoOfMachines-1].endRow += remainder;
        
 	CORBA::Object_var obj[NoOfMachines];
 	
        matrix_var Client[NoOfMachines];
        CORBA::Object_ptr obj_req[NoOfMachines];
        CORBA::Request_ptr req[NoOfMachines];
	for(i=0;i<NoOfMachines;i++) {
		obj[i] = orb -> bind("IDL:matrix:1.0", argv[1+i]);
        	if  (CORBA::is_nil (obj[i]) ){
                  cout << "exception in the client code" << endl;
                  cout << "no such object " << endl;
                  return 0;
        	}
        	Client[i] = matrix::_narrow(obj[i]);
        	obj_req[i] = (CORBA::Object_ptr) Client[i];
        	req[i] = obj_req[i] -> _request("Multiply");
		req[i]->add_in_arg("Multiply") <<= Input[i];
		// req[i]->add_out_arg("Multiply") >>= ResultArray;
	}               
	int ReturnValueTime;
        struct timeval tvBefore, tvAfter;
        ReturnValueTime = gettimeofday(&tvBefore, (struct timezone*)0);
        if ( ReturnValueTime == -1 ) {
                  cout << " gettime of day cribbed  " << endl;
                  return 0;
        }
	static struct rusage ru1,ru2;
        double real1, real2,real_diff, systime1, systime2, utime1, utime2, sysdiff, udiff;
	getrusage ( RUSAGE_SELF, &ru1 );
	int pid, pid1;
	pid = fork();
	pid1 = fork();
	if ( (pid == 0) && (pid1 == 0) ) {
		cout << " in 1st process, about to call handler " << endl;
		int p = Handler(req[0], 0);
		cout << " in 1st process, after to call handler " << endl;
	}
	if ( (pid == 0) && (pid1 != 0) ) {
		int p = Handler(req[1], 0);
		ReturnValueTime = gettimeofday(&tvAfter, (struct timezone*)0);
        	if ( ReturnValueTime == -1 ) {
                	   cout << " gettime of day cribbed  " << endl;
                   	return 0;
        	}
        	float diff = (float) (tvAfter.tv_sec - tvBefore.tv_sec) +(float) (tvAfter.tv_usec - tvBefore.tv_usec)* 0.000001; 
		cout << "the real time taken is     " << diff << endl;
		getrusage ( RUSAGE_SELF, &ru2 );
		systime1 = ru1.ru_stime.tv_sec + (0.000001 * ru1.ru_stime.tv_usec);
	        systime2 = ru2.ru_stime.tv_sec + (0.000001 * ru2.ru_stime.tv_usec);
        	utime1 = ru1.ru_utime.tv_sec + (0.000001 * ru1.ru_utime.tv_usec);
        	utime2 = ru2.ru_utime.tv_sec + (0.000001 * ru2.ru_utime.tv_usec);
        	cout << "system time taken is  " << systime2-systime1 << endl;
        	cout << "user time taken is  " << utime2-utime1 << endl;
        	cout <<" total time taken is " << systime2-systime1+utime2-utime1;
		fflush(stdout);
	}
	if ( (pid != 0) && (pid1 == 0) ) {
		cout << " in 2nd process, about to call handler " << endl;
		int p = Handler(req[2], 0);
		cout << " in 2nd process, after to call handler " << endl;
	}
	if ( (pid != 0) && (pid1 != 0) ) {
		cout << " in 3rd process, about to call handler " << endl;
		// int p = Handler(req[3], 0);
		cout << " in 3rd process, after to call handler " << endl;
	}
	fflush(stdout);
}
