/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__MATRIX_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __MATRIX_H__

#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif

typedef CORBA::Long Array[ 500 ][ 500 ];
typedef CORBA::Long Array_slice[ 500 ];
typedef ArrayFixVar<CORBA::Long,Array_slice,Array,250000> Array_var;
typedef Array_var Array_out;
enum _dummy_Array { _dummy_Array_0 };
typedef ArrayFixForAny<CORBA::Long,Array_slice,Array,250000,_dummy_Array> Array_forany;
#undef MICO_ARRAY_ARG
#define MICO_ARRAY_ARG CORBA::Long
DECLARE_ARRAY_ALLOC(Array,MICO_ARRAY_ARG,Array_slice,250000)
DECLARE_ARRAY_DUP(Array,MICO_ARRAY_ARG,Array_slice,250000)
DECLARE_ARRAY_FREE(Array,MICO_ARRAY_ARG,Array_slice,250000)
DECLARE_ARRAY_COPY(Array,MICO_ARRAY_ARG,Array_slice,250000)
struct argument;
typedef TFixVar<argument> argument_var;
typedef argument_var argument_out;

struct argument {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef argument_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  argument();
  ~argument();
  argument( const argument& s );
  argument& operator=( const argument& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  CORBA::Long startRow;
  CORBA::Long endRow;
  CORBA::Long dim;
  CORBA::Long a[ 500 ][ 500 ];
  CORBA::Long b[ 500 ][ 500 ];
};

typedef argument argumenttype;
#ifdef _WINDOWS
static argumenttype _dummy_argumenttype;
#endif
typedef argument_var argumenttype_var;
typedef argumenttype_var argumenttype_out;

class matrix;
typedef matrix *matrix_ptr;
typedef matrix_ptr matrixRef;
typedef ObjVar<matrix> matrix_var;
typedef matrix_var matrix_out;


// Common definitions for interface matrix
class matrix : 
  virtual public CORBA::Object
{
  public:
    virtual ~matrix();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef matrix_ptr _ptr_type;
    typedef matrix_var _var_type;
    #endif

    static matrix_ptr _narrow( CORBA::Object_ptr obj );
    static matrix_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static matrix_ptr _duplicate( matrix_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static matrix_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual void Multiply( const argumenttype& InputStruct ) = 0;

  protected:
    matrix() {};
  private:
    matrix( const matrix& );
    void operator=( const matrix& );
};

// Stub for interface matrix
class matrix_stub:
  virtual public matrix
{
  public:
    virtual ~matrix_stub();
    void Multiply( const argumenttype& InputStruct );

  private:
    void operator=( const matrix_stub& );
};

#ifndef MICO_CONF_NO_POA

class matrix_stub_clp :
  virtual public matrix_stub,
  virtual public PortableServer::StubBase
{
  public:
    matrix_stub_clp (PortableServer::POA_ptr, CORBA::Object_ptr);
    virtual ~matrix_stub_clp ();
    void Multiply( const argumenttype& InputStruct );

  protected:
    matrix_stub_clp ();
  private:
    void operator=( const matrix_stub_clp & );
};

#endif // MICO_CONF_NO_POA

#ifndef MICO_CONF_NO_POA

class POA_matrix : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~POA_matrix ();
    matrix_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static POA_matrix * _narrow (PortableServer::Servant);
    virtual CORBA::Object_ptr _make_stub (PortableServer::POA_ptr, CORBA::Object_ptr);

    virtual void Multiply( const argumenttype& InputStruct ) = 0;

  protected:
    POA_matrix () {};

  private:
    POA_matrix (const POA_matrix &);
    void operator= (const POA_matrix &);
};

template<class T>
class POA_matrix_tie : 
  virtual public POA_Tie_Base<T>,
  virtual public POA_matrix
{
  public:
    POA_matrix_tie (T &t)
      : POA_Tie_Base<T> (&t, PortableServer::POA::_nil(), FALSE)
    {}
    POA_matrix_tie (T &t, PortableServer::POA_ptr _poa)
      : POA_Tie_Base<T> (&t, _poa, FALSE)
    {}
    POA_matrix_tie (T *t, CORBA::Boolean _rel = TRUE)
      : POA_Tie_Base<T> (t, PortableServer::POA::_nil(), _rel)
    {}
    POA_matrix_tie (T *t, PortableServer::POA_ptr _poa, CORBA::Boolean _rel = TRUE)
      : POA_Tie_Base<T> (t, _poa, _rel)
    {}
    virtual ~POA_matrix_tie ();

    PortableServer::POA_ptr _default_POA ();

    void Multiply( const argumenttype& InputStruct );

  protected:
    POA_matrix_tie () {};

  private:
    POA_matrix_tie (const POA_matrix_tie<T> &);
    void operator= (const POA_matrix_tie<T> &);
};

template<class T>
POA_matrix_tie<T>::~POA_matrix_tie ()
{
}

template<class T>
PortableServer::POA_ptr
POA_matrix_tie<T>::_default_POA ()
{
  if (!CORBA::is_nil (POA_Tie_Base<T>::poa)) {
    return PortableServer::POA::_duplicate (POA_Tie_Base<T>::poa);
  }
  return PortableServer::ServantBase::_default_POA ();
}

template<class T>
void
POA_matrix_tie<T>::Multiply (const argumenttype& InputStruct)
{
  POA_Tie_Base<T>::ptr->Multiply (InputStruct);
}

#endif // MICO_CONF_NO_POA

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

extern CORBA::StaticTypeInfo *_marshaller_argument;

extern CORBA::StaticTypeInfo *_marshaller_matrix;

extern CORBA::StaticTypeInfo *_marshaller__a500__a500_long;

extern CORBA::StaticTypeInfo *_marshaller__a500_long;

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#if !defined(MICO_NO_TOPLEVEL_MODULES) && !defined(MICO_IN_GENERATED_CODE)
#include <mico/template_impl.h>
#endif

#endif
