/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__MATRIX_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __MATRIX_H__

#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif

typedef CORBA::Long Array[ 500 ][ 500 ];
typedef CORBA::Long Array_slice[ 500 ];
typedef ArrayFixVar<CORBA::Long,Array_slice,Array,250000> Array_var;
typedef Array_var Array_out;
class _dummy_Array {};
typedef ArrayForAny<CORBA::Long,Array_slice,Array,250000,_dummy_Array> Array_forany;
DECLARE_ARRAY_ALLOC(Array,CORBA::Long,Array_slice,250000)
DECLARE_ARRAY_DUP(Array,CORBA::Long,Array_slice,250000)
DECLARE_ARRAY_FREE(Array,CORBA::Long,Array_slice,250000)
DECLARE_ARRAY_COPY(Array,CORBA::Long,Array_slice,250000)
extern CORBA::TypeCodeConst _tc_Array;

struct argument {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  argument();
  ~argument();
  argument( const argument& s );
  argument& operator=( const argument& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS
  CORBA::Long startRow;
  CORBA::Long endRow;
  CORBA::Long dim;
  CORBA::Float a[ 500 ][ 500 ];
  CORBA::Float b[ 500 ][ 500 ];
};

typedef TFixVar<argument> argument_var;
typedef argument_var argument_out;

extern CORBA::TypeCodeConst _tc_argument;

typedef argument argumenttype;
#ifdef _WINDOWS
static argumenttype _dummy_argumenttype;
#endif
typedef argument_var argumenttype_var;
typedef argumenttype_var argumenttype_out;

extern CORBA::TypeCodeConst _tc_argumenttype;

class matrix;
typedef matrix *matrix_ptr;
typedef matrix_ptr matrixRef;
typedef ObjVar<matrix> matrix_var;
typedef matrix_var matrix_out;


// Common definitions for interface matrix
class matrix : virtual public CORBA::Object
{
  public:
    virtual ~matrix();
    static matrix_ptr _duplicate( matrix_ptr obj );
    static matrix_ptr _narrow( CORBA::Object_ptr obj );
    static matrix_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual void Multiply( const argumenttype& InputStruct, Array a ) = 0;
  protected:
    matrix() {};
  private:
    matrix( const matrix& );
    void operator=( const matrix& );
};

extern CORBA::TypeCodeConst _tc_matrix;

// Stub for interface matrix
class matrix_stub : virtual public matrix
{
  public:
    virtual ~matrix_stub();
    void Multiply( const argumenttype& InputStruct, Array a );
  private:
    void operator=( const matrix_stub& );
};

class POA_matrix : virtual public PortableServer::DynamicImplementation
{
  public:
    virtual ~POA_matrix ();
    matrix_ptr _this ();
    bool dispatch (CORBA::ServerRequest_ptr);
    virtual bool _is_a (const char *);
    virtual void invoke (CORBA::ServerRequest_ptr);
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void Multiply( const argumenttype& InputStruct, Array a ) = 0;

  protected:
    POA_matrix () {};

  private:
    POA_matrix (const POA_matrix &);
    void operator= (const POA_matrix &);
};

template<class T>
class POA_matrix_tie : 
  virtual public POA_Tie_Base<T>,
  virtual public POA_matrix
{
  public:
    POA_matrix_tie (T &t)
      : POA_Tie_Base<T> (&t, PortableServer::POA::_nil(), FALSE)
    {}
    POA_matrix_tie (T &t, PortableServer::POA_ptr _poa)
      : POA_Tie_Base<T> (&t, _poa, FALSE)
    {}
    POA_matrix_tie (T *t, CORBA::Boolean _rel = TRUE)
      : POA_Tie_Base<T> (t, PortableServer::POA::_nil(), _rel)
    {}
    POA_matrix_tie (T *t, PortableServer::POA_ptr _poa, CORBA::Boolean _rel = TRUE)
      : POA_Tie_Base<T> (t, _poa, _rel)
    {}
    virtual ~POA_matrix_tie ();

    PortableServer::POA_ptr _default_POA ();

    void Multiply( const argumenttype& InputStruct, Array a );

  protected:
    POA_matrix_tie () {};

  private:
    POA_matrix_tie (const POA_matrix_tie &);
    void operator= (const POA_matrix_tie &);
};

template<class T>
POA_matrix_tie<T>::~POA_matrix_tie ()
{
}

template<class T>
PortableServer::POA_ptr
POA_matrix_tie<T>::_default_POA ()
{
  if (!CORBA::is_nil (POA_Tie_Base<T>::poa)) {
    return PortableServer::POA::_duplicate (POA_Tie_Base<T>::poa);
  }
  return PortableServer::DynamicImplementation::_default_POA ();
}

template<class T>
void
POA_matrix_tie<T>::Multiply (const argumenttype& InputStruct, Array a)
{
  POA_Tie_Base<T>::ptr->Multiply (InputStruct, a);
}

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

CORBA::Boolean operator<<=( CORBA::Any &_a, const ::Array_forany &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, ::Array_forany &_s );
CORBA::Boolean operator<<=( CORBA::Any &_a, const ::argument &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, ::argument &_s );

CORBA::Boolean operator<<=( CORBA::Any &a, const matrix_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, matrix_ptr &obj );

CORBA::Boolean operator<<=( CORBA::Any &_a, CORBA::Long (&_s)[ 500 ][ 500 ] );
CORBA::Boolean operator>>=( const CORBA::Any &_a, CORBA::Long (&_s)[ 500 ][ 500 ] );

CORBA::Boolean operator<<=( CORBA::Any &_a, CORBA::Long (&_s)[ 500 ] );
CORBA::Boolean operator>>=( const CORBA::Any &_a, CORBA::Long (&_s)[ 500 ] );

CORBA::Boolean operator<<=( CORBA::Any &_a, CORBA::Float (&_s)[ 500 ][ 500 ] );
CORBA::Boolean operator>>=( const CORBA::Any &_a, CORBA::Float (&_s)[ 500 ][ 500 ] );

CORBA::Boolean operator<<=( CORBA::Any &_a, CORBA::Float (&_s)[ 500 ] );
CORBA::Boolean operator>>=( const CORBA::Any &_a, CORBA::Float (&_s)[ 500 ] );

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#if !defined(MICO_NO_TOPLEVEL_MODULES) && !defined(MICO_IN_GENERATED_CODE)
#include <mico/template_impl.h>
#endif

#endif
