/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include "matrix.h"
#include "matrix.cc"
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>
#define Dimension 500
#define MAX_DIM 500
#define NoOfMachines 3
long ResultArray[MAX_DIM][MAX_DIM];


int main(int argc, char *argv[]) {
      	int i,j = 0, k, p, q;
	char *hosts[NoOfMachines];
	for(i=2;i<argc;i++,j++) {
		hosts[j] = new char[30];
                hosts[j] = argv[i];
                // cout << host[j++] << endl;
        }

	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv, "mico-local-orb");
	// int NoOfMachines = argc;
     	argumenttype Input[NoOfMachines]; 
	srand(900);
	for (i=0;i<Dimension;i++) {
		for (j=0;j<Dimension;j++) {
			ResultArray[i][j] = 0;
		}
	}
	for(k=0;k<NoOfMachines;k++) {
		Input[k].dim = Dimension;
  		for(i=0;i<Dimension;i++){
    			for(j=0;j<Dimension;j++){
      				Input[k].a[i][j] = 0;
     			 	Input[k].b[i][j] = rand() % 10;  
				/* to ensure a number between 0 and 9 */
    			}
  		}
	}
	for(k=0;k<NoOfMachines;k++) 
  	for(i=0;i<Input[k].dim;i++)
    		Input[k].a[i][i] = 1;
	
	// partition the array
	int remainder = Dimension % NoOfMachines;
	int value = Dimension/NoOfMachines;
	int initializer = 0;
	for(i=0;i<NoOfMachines;i++) {
		Input[i].startRow = initializer;
		Input[i].endRow = initializer + value - 1;
		initializer +=value;
	}
	Input[NoOfMachines-1].endRow += remainder;
        
 	CORBA::Object_ptr obj[NoOfMachines];
 	
        matrix_var ClientRef[NoOfMachines];
        CORBA::Object_ptr obj_req[NoOfMachines];
        CORBA::Request_ptr req[NoOfMachines];
	for(i=0;i<NoOfMachines;i++) {
		cout << "binding to " << hosts[i] << endl;
		obj[i] = orb -> bind("IDL:matrix:1.0", hosts[i]);
        	if  (CORBA::is_nil (obj[i]) ){
                  cout << "exception in the client code" << endl;
                  cout << "no such object " << endl;
                  return 0;
        	}
        	ClientRef[i] = matrix::_narrow(obj[i]);
	}               
	int ReturnValueTime;
        struct timeval tvBefore, tvAfter;
        ReturnValueTime = gettimeofday(&tvBefore, (struct timezone*)0);
        if ( ReturnValueTime == -1 ) {
                  cout << " gettime of day cribbed  " << endl;
                  return 0;
        }
	static struct rusage ru1,ru2;
        double real1, real2,real_diff, systime1, systime2, utime1, utime2, sysdiff, udiff;
	getrusage ( RUSAGE_SELF, &ru1 );
	for(i=0;i<NoOfMachines;i++) {
		ClientRef[i]->Multiply(Input[i]);
	}


	ReturnValueTime = gettimeofday(&tvAfter, (struct timezone*)0);
       	if ( ReturnValueTime == -1 ) {
               	   cout << " gettime of day cribbed  " << endl;
                 	return 0;
       	}
       	float diff = (float) (tvAfter.tv_sec - tvBefore.tv_sec) +(float) (tvAfter.tv_usec - tvBefore.tv_usec)* 0.000001; 
	cout << "the real time taken is     " << diff << endl;
	getrusage ( RUSAGE_SELF, &ru2 );
	systime1 = ru1.ru_stime.tv_sec + (0.000001 * ru1.ru_stime.tv_usec);
        systime2 = ru2.ru_stime.tv_sec + (0.000001 * ru2.ru_stime.tv_usec);
       	utime1 = ru1.ru_utime.tv_sec + (0.000001 * ru1.ru_utime.tv_usec);
       	utime2 = ru2.ru_utime.tv_sec + (0.000001 * ru2.ru_utime.tv_usec);
       	cout << "system time taken is  " << systime2-systime1 << endl;
       	cout << "user time taken is  " << utime2-utime1 << endl;
       	cout <<" total time taken is " << systime2-systime1+utime2-utime1;
	fflush(stdout);
}
