/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include <rpc/rpc.h>
#include <rpcsvc/rstat.h>
#include "mytime.c"
#define MAX_DIM 500

typedef struct {
  int noOfRows;
  int dim;
  int a[MAX_DIM][MAX_DIM];
  int b[MAX_DIM][MAX_DIM];
} argumentType;

argumentType args;
argumentType result;

/* float getMyLF(void)        
{
  char hostname[30];
  struct statstime *statp;
  float ret;

  gethostname(hostname,30);
  statp = (struct statstime *) malloc(sizeof(struct statstime));

  if (rstat(hostname,statp)==0){
    ret = (float) statp->avenrun[0];
    free(statp);
    return ret;
  }
  else{
    printf("unable to calculate  load factor. Exiting ..\n");
    free(statp);
    exit(1);
  }
}  */

char* matmul(char* data)
{
  argumentType* argument;
  argumentType* result;
  int sum;
  int i,j,k;

  argument = (argumentType *)data;
  result = (argumentType *)malloc(sizeof(argumentType));
  
  result->noOfRows = argument->noOfRows;
  result->dim = argument->dim;

  for(i=0; i<argument->noOfRows; i++){
    for(j=0; j<argument->dim; j++){
      sum = 0;
      for(k=0; k<argument->dim; k++){
	sum+= ((argument)->a[i][k]) * ((argument)->b[k][j]);
      }
      (result)->a[i][j] = sum;
    }
  }
  return((char *)result);
}

void main()
{
  int i,j;
  
  printf("Enter dimension : ");
  scanf("%d", &(args.dim));

 /* printf("Load factor = %f", getMyLF()); */
  
  my_process_time(1);

  args.noOfRows = args.dim;
  
  for(i=0;i<args.dim;i++){
    for(j=0;j<args.dim;j++){
      args.a[i][j] = 0;
      args.b[i][j] = rand();
    }
  }
  
  for(i=0;i<args.dim;i++)
    args.a[i][i] = 1;

  result = *(argumentType *)matmul((char *)(&args));
  
  my_process_time(2);

  my_process_time(3);

  /*
  for(i=0; i<args.dim; i++){
    for(j=0; j<args.dim; j++){
      printf("%d ",args.a[i][j]);
    }
    printf("\n");
  }

  printf("\n");

  for(i=0; i<args.dim; i++){
    for(j=0; j<args.dim; j++){
      printf("%d ",args.b[i][j]);
    }
    printf("\n");
  }
  
   printf("\n");

  for(i=0; i<result.dim; i++){
    for(j=0; j<result.dim; j++){
      printf("%d ",result.a[i][j]);
    }
    printf("\n");
  }
  */
  printf("over\n");
}


