/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include <stdio.h>
#include <sys/time.h>
#include <string.h>
#include <sys/types.h>
#include <sys/times.h>
#include <sys/resource.h>


double my_real_time ();

double my_process_time ();

double my_real_time (int pass)

/* pass=1		first call
 * paas=2		second call
 * pass=3		print the difference */

{
static struct timeval tp1, tp2;
static struct timezone tzp1, tzp2;

int i;

  switch (pass) {
	case 1: i = gettimeofday(&tp1, &tzp1); break;
	case 2: i = gettimeofday(&tp2, &tzp2); break;
	case 3: /* printf ("tp.tv_sec1 = %ld\n",tp1.tv_sec);
		printf ("tp.tv_usec1 = %ld\n",tp1.tv_usec);
		printf ("tp.tv_sec2 = %ld\n",tp2.tv_sec);
		printf ("tp.tv_usec2 = %ld\n",tp2.tv_usec); 
		printf ("sec = %ld,",tp2.tv_sec-tp1.tv_sec); 
		printf ("usec = %ld\n",tp2.tv_usec-tp1.tv_usec);*/
		/* printf ("%f\n", (float) (tp2.tv_sec-tp1.tv_sec) + ( (float) (tp2.tv_usec-tp1.tv_usec) * 0.000001 )); */
		return ((float) (tp2.tv_sec-tp1.tv_sec) + ( (float) (tp2.tv_usec-tp1.tv_usec) * 0.000001 ));
		break;
  }
  return (0);
}

/*********************************************************/

double my_process_time (int pass)

{
static struct rusage ru1,ru2;
static struct timeval tp1, tp2;
static struct timezone tzp1, tzp2;

double real1, real2,real_diff, systime1, systime2, utime1, utime2, sysdiff, udiff;

int i;


	switch (pass) {

	case 1: 
		getrusage ( RUSAGE_SELF, &ru1 );
		i = gettimeofday(&tp1, &tzp1);
		break;

	case 2: 
		getrusage ( RUSAGE_SELF, &ru2 ); 
		i = gettimeofday(&tp2, &tzp2);
		break;
	case 3:

#ifdef SPARC
#define tv_usec tv_nsec /* on sparc, nano secs are reported */
#endif			/* instead of micro seconds */


		systime1 = ru1.ru_stime.tv_sec + (0.000001 * ru1.ru_stime.tv_usec);
		systime2 = ru2.ru_stime.tv_sec + (0.000001 * ru2.ru_stime.tv_usec);
		utime1 = ru1.ru_utime.tv_sec + (0.000001 * ru1.ru_utime.tv_usec);
		utime2 = ru2.ru_utime.tv_sec + (0.000001 * ru2.ru_utime.tv_usec);

		printf ("***systime: %lf    usertime:%lf total: %lf\n", 
				systime2-systime1,utime2-utime1, systime2-systime1+utime2-utime1); 
		/*printf ("tp.tv_sec1 = %ld\n",tp1.tv_sec);
		printf ("tp.tv_usec1 = %ld\n",tp1.tv_usec);
		printf ("tp.tv_sec2 = %ld\n",tp2.tv_sec);
		printf ("tp.tv_usec2 = %ld\n",tp2.tv_usec); */
/* now again nsec should be reset to usec for timeval */

		real1 = tp1.tv_sec + (0.000001 * tp1.tv_usec);
		real2 = tp2.tv_sec + (0.000001 * tp2.tv_usec);
		real_diff = (real2-real1);
		printf ("****real time = %lf seconds\n",real_diff);
		return (real_diff);
		break;
	}
	return (0);
}


