/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__MIGRATIONSERVICE_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __MIGRATIONSERVICE_H__

#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif

struct Str;
typedef TVarVar<Str> Str_var;
typedef Str_var Str_out;

struct Str {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef Str_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  Str();
  ~Str();
  Str( const Str& s );
  Str& operator=( const Str& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  CORBA::String_var str;
};

typedef Str S2;
#ifdef _WINDOWS
static S2 _dummy_S2;
#endif
typedef Str_var S2_var;
typedef S2_var S2_out;

class MigrationService;
typedef MigrationService *MigrationService_ptr;
typedef MigrationService_ptr MigrationServiceRef;
typedef ObjVar<MigrationService> MigrationService_var;
typedef MigrationService_var MigrationService_out;


// Common definitions for interface MigrationService
class MigrationService : 
  virtual public CORBA::Object
{
  public:
    virtual ~MigrationService();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef MigrationService_ptr _ptr_type;
    typedef MigrationService_var _var_type;
    #endif

    static MigrationService_ptr _narrow( CORBA::Object_ptr obj );
    static MigrationService_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static MigrationService_ptr _duplicate( MigrationService_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static MigrationService_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual void Migrate( const char* OldAddress, const char* NewAddress, const char* InterfaceName ) = 0;

  protected:
    MigrationService() {};
  private:
    MigrationService( const MigrationService& );
    void operator=( const MigrationService& );
};

// Stub for interface MigrationService
class MigrationService_stub:
  virtual public MigrationService
{
  public:
    virtual ~MigrationService_stub();
    void Migrate( const char* OldAddress, const char* NewAddress, const char* InterfaceName );

  private:
    void operator=( const MigrationService_stub& );
};

#ifndef MICO_CONF_NO_POA

class MigrationService_stub_clp :
  virtual public MigrationService_stub,
  virtual public PortableServer::StubBase
{
  public:
    MigrationService_stub_clp (PortableServer::POA_ptr, CORBA::Object_ptr);
    virtual ~MigrationService_stub_clp ();
    void Migrate( const char* OldAddress, const char* NewAddress, const char* InterfaceName );

  protected:
    MigrationService_stub_clp ();
  private:
    void operator=( const MigrationService_stub_clp & );
};

#endif // MICO_CONF_NO_POA

#ifndef MICO_CONF_NO_POA

class POA_MigrationService : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~POA_MigrationService ();
    MigrationService_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static POA_MigrationService * _narrow (PortableServer::Servant);
    virtual CORBA::Object_ptr _make_stub (PortableServer::POA_ptr, CORBA::Object_ptr);

    virtual void Migrate( const char* OldAddress, const char* NewAddress, const char* InterfaceName ) = 0;

  protected:
    POA_MigrationService () {};

  private:
    POA_MigrationService (const POA_MigrationService &);
    void operator= (const POA_MigrationService &);
};

template<class T>
class POA_MigrationService_tie : 
  virtual public POA_Tie_Base<T>,
  virtual public POA_MigrationService
{
  public:
    POA_MigrationService_tie (T &t)
      : POA_Tie_Base<T> (&t, PortableServer::POA::_nil(), FALSE)
    {}
    POA_MigrationService_tie (T &t, PortableServer::POA_ptr _poa)
      : POA_Tie_Base<T> (&t, _poa, FALSE)
    {}
    POA_MigrationService_tie (T *t, CORBA::Boolean _rel = TRUE)
      : POA_Tie_Base<T> (t, PortableServer::POA::_nil(), _rel)
    {}
    POA_MigrationService_tie (T *t, PortableServer::POA_ptr _poa, CORBA::Boolean _rel = TRUE)
      : POA_Tie_Base<T> (t, _poa, _rel)
    {}
    virtual ~POA_MigrationService_tie ();

    PortableServer::POA_ptr _default_POA ();

    void Migrate( const char* OldAddress, const char* NewAddress, const char* InterfaceName );

  protected:
    POA_MigrationService_tie () {};

  private:
    POA_MigrationService_tie (const POA_MigrationService_tie<T> &);
    void operator= (const POA_MigrationService_tie<T> &);
};

template<class T>
POA_MigrationService_tie<T>::~POA_MigrationService_tie ()
{
}

template<class T>
PortableServer::POA_ptr
POA_MigrationService_tie<T>::_default_POA ()
{
  if (!CORBA::is_nil (POA_Tie_Base<T>::poa)) {
    return PortableServer::POA::_duplicate (POA_Tie_Base<T>::poa);
  }
  return PortableServer::ServantBase::_default_POA ();
}

template<class T>
void
POA_MigrationService_tie<T>::Migrate (const char* OldAddress, const char* NewAddress, const char* InterfaceName)
{
  POA_Tie_Base<T>::ptr->Migrate (OldAddress, NewAddress, InterfaceName);
}

#endif // MICO_CONF_NO_POA

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

extern CORBA::StaticTypeInfo *_marshaller_Str;

extern CORBA::StaticTypeInfo *_marshaller_MigrationService;

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#if !defined(MICO_NO_TOPLEVEL_MODULES) && !defined(MICO_IN_GENERATED_CODE)
#include <mico/template_impl.h>
#endif

#endif
