/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include "Cool.cc"
#include "MigrationService.cc"
#include "Kernel.h"
#include "Kernel.cc"
#include <sys/time.h>

#define M 3
// #define M 2

int main(int argc, char *argv[]) {
	int i;
	int k;
	char *MachineNamesKernel[M];
	char *TargetName[M];
        List AvailableMachinesList;
	for(i=0;i<M;i++) {
                AvailableMachinesList[i] = 0;
                MachineNamesKernel[i] = new char[30];
                TargetName[i] = new char[30];
		
                // 0 indicates that m/c cant be used
        }
	strcpy(MachineNamesKernel[0],"inet:malli:9900");
        strcpy(MachineNamesKernel[1],"inet:jasmine:9900");	
        strcpy(MachineNamesKernel[2],"inet:rose:9900");

	strcpy(TargetName[0],"inet:malli:9999");
        strcpy(TargetName[1],"inet:jasmine:9999");	
        strcpy(TargetName[2],"inet:rose:9999");

        CORBA::ORB_var orb = CORBA::ORB_init(argc, argv, "mico-local-orb");
	
	CORBA::Object_var MigObj = orb -> 
				bind("IDL:MigrationService:1.0",argv[1]);
	MigrationService_ptr MigRef = MigrationService::_narrow(MigObj);
	if ( CORBA::is_nil (MigRef) ) {
                printf ("oops: Mig Reference is nil\n");
                exit (1);
        }

	// target for migration to be determined by making calls to
	// kernel entity.
	
	/* CORBA::Object_var obj = orb->bind("IDL:Kernel:1.0", MachineNamesKernel[1]);
	// kernel entity in local machine 

         Kernel_var ClientRef = Kernel::_narrow(obj);
        if (CORBA::is_nil(ClientRef) ) {
                printf("oops : Reference is nil\n");
                exit(1);
        }*/
	double LoadValue;
	// load monitor. if load exceeds threshold, get machines list and
	// migrate the object. else, do nothing like an ostrich.
	// ClientRef->GetLocalLoadConditions(LoadValue);
	/* for(;;) {
        	ClientRef->GetMachinesList(AvailableMachinesList);
		if (AvailableMachinesList[1] != 0) {
        // this means that local m/c load has not exceeded threshold
        // sleep for some time and keep monitoring.
                	sleep(100);
        	} 
		else {
	// local m/c load has exceeded threshold, so migrate the
	// object to a different m/c.
			break;
		}
	} */ // end of monitoring, migrate the object. 
	
       	/* ClientRef->GetMachinesList(AvailableMachinesList);

        for(i=0;i<M;i++){
                cout << AvailableMachinesList[i] << " " ;
		cout << MachineNamesKernel[i] << endl;
		if ( (AvailableMachinesList[i] == 1) && 
			(strcmp(TargetName[i],"inet:jasmine:9999") != 0) ) {
			// cant migrate it to local m/c itself.
			k = i;
			cout << " Target m/c is "  << TargetName[k];
		}
        } */
		
	// MigRef -> Migrate(s1 ,s2); 
	// MigRef -> Migrate("inet:malli:9000", "inet:jasmine:8900"); 
	char * OldAddress = new char [30];
	char * NewAddress = new char [30];
	char * InterfaceName= new char [30];
	strcpy(OldAddress,"inet:jasmine:8900");
	// strcpy(NewAddress, "inet:malli:9000");
	strcpy(InterfaceName, "Cool");
	//  from list of available machines, k is one.

	CORBA::Object_var objTemp = orb->bind("IDL:Cool:1.0", OldAddress);
	if ( CORBA::is_nil (objTemp) ) {
                printf ("oops: Old Reference is nil\n");
                exit (1);
        }

	char *ObjRef = new char[30];
	ObjRef = orb->object_to_string(objTemp);
	//strcpy(NewAddress, TargetName[k]);
	int ReturnValueTime;
	struct timeval tvBefore, tvAfter;


        ReturnValueTime = gettimeofday(&tvBefore, (struct timezone*)0); 
	if ( ReturnValueTime == -1 ) {
             cout << " gettime of day cribbed  " << endl;
             return 1;
        }

	MigRef -> Migrate(ObjRef, "inet:rose:9999", InterfaceName); 
	ReturnValueTime = gettimeofday(&tvAfter, (struct timezone*)0);
        if ( ReturnValueTime == -1 ) {
               cout << " gettime of day cribbed  " << endl;
               return 1;
        }
        long diff = (tvAfter.tv_sec - tvBefore.tv_sec)*1000 + (tvAfter.tv_usec - tvBefore.tv_usec)/1000;
	cout << "the migration delay is " << diff <<"millisecs" << endl;	

	// MigRef -> Migrate(ObjRef, NewAddress, InterfaceName); 
	CORBA::Object_var objNew = orb->bind("IDL:Cool:1.0", "inet:rose:9999");
	if ( CORBA::is_nil (objNew) ) {
                printf ("oops: Old Reference is nil\n");
                exit (1);
        }
	Cool_var NewRef = Cool::_narrow(objNew);
	//NewRef->Compute(Tour);	
}


