/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include "MigrationService.cc"
#include "MigrationService_impl.cc"

int main(int argc, char *argv[]) {

        CORBA::ORB_var orb = CORBA::ORB_init(argc, argv, "mico-local-orb");

        CORBA::Object_var poaobj = orb->resolve_initial_references("RootPOA");
        PortableServer::POA_var poa = PortableServer::POA::_narrow (poaobj);
        PortableServer::POAManager_var mgr = poa->the_POAManager();

        MigrationService_impl *Server = new MigrationService_impl();
        PortableServer::ObjectId_var oid = poa->activate_object (Server);

        mgr->activate ();

        orb -> run();
        poa->destroy (TRUE, TRUE);
        delete Server;

        return 0;
}

