/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#define CC_AC_PORT 5500
#define DR_AC_PORT 5900
#define AC_UP_PORT "/tmp/ACUP"
#define FILENAME_LENGTH	25

typedef struct tagDonorList
{
	//HOST_DESCRIPTOR ACHost;
	int DRSock;
	int DRCSock;
	char *DRHostName;
	char *DRLoginName;
	char *DRDaemonPath;
	double DRHPF;
	
	struct tagDonorList *next;

} DRLIST, *P_DRLIST;


typedef struct tagSplitInfo
{
	int SID;
	double LB;
	double UB;
	double MinSplit;
	int DRSock;
	int DRCSock;
	char *DRHostName;
	double result;	
	struct tagSplitInfo *next;
}SPLIT, *P_SPLIT;

typedef struct tagTaskInfo
{
	int TID;
	char *filename;
	double LB;
	double UB;
	double MinSplit;
	char op;
	double result;	
	struct tagSplitInfo *pSStart;
	struct tagSplitInfo *pSEnd;
	struct tagTaskInfo *next;
}TASK, *P_TASK;


int AnyDataToRead(fd_set *rfd);
int ProcessMessage(int sock);
int ProcessUserMessage(int sock);
int ReceiveHPF(int sock, int MessgID);
int SearchList();
int GetDonors(int sock);
int GetHPF();
int ConnectDonors();
int GetProbData(int sock);
int SplitTheTask();
int GetClusters(int sock);			
int ReceiveResults(int sock);
