/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */


#ifndef __GCXDRROUTINES_H__

#define  __GCXDRROUTINES_H__

#define LENGTH_FIELD_FOR_XDR_STRING   30


/******************************************************* Write Prototypes *************************************************************/

int WriteXDRSignedChar(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int adtype);
int WriteXDRUnSignedChar(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int adtype);

int WriteXDRSignedShortInteger(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int adtype);
int WriteXDRUnSignedShortInteger(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int adtype);

int WriteXDRSignedInteger(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int adtype);
int WriteXDRUnSignedInteger(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int adtype);

int WriteXDRSignedLongInteger(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int adtype);
int WriteXDRUnSignedLongInteger(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int adtype);

int WriteXDRString(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int adtype);

int WriteXDRFloat(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int adtype);

int WriteXDRDouble(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int adtype);


/******************************************************* Read Prototypes *************************************************************/

int ReadXDRSignedChar(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int a_nWhichHost);
int ReadXDRUnSignedChar(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int a_nWhichHost);

int ReadXDRSignedShortInteger(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int a_nWhichHost);
int ReadXDRUnSignedShortInteger(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int a_nWhichHost);

int ReadXDRSignedInteger(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int a_nWhichHost);
int ReadXDRUnSignedInteger(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int a_nWhichHost);

int ReadXDRSignedLongInteger(int sock,int a_nMessageID,void* a_pDataElement, int a_nSize,int a_nWhichHost);
int ReadXDRUnSignedLongInteger(int sock,int a_nMessageID, void* a_pDataElement, int a_nSize, int a_nWhichHost);

int ReadXDRString(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int a_nWhichHost);

int ReadXDRFloat(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int a_nWhichHost);

int ReadXDRDouble(int sock, int a_nMessageID, void *a_pDataElement, int a_nSize, int a_nWhichHost);


#endif
