/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <stdlib.h>
#include <unistd.h> /* For write() function call to write into the result file*/
#define PI 3.13

/* Three arguments have to be passed. argv[1]->lower bound, argv[2]->upper bound, 
arg[3]->any text filename to print the result like temp.txt */

int main(int argc, char *argv[])
{
    struct timeval time1;
    long stime_s, stime_m, etime_s, etime_m; 
   
    long long res=0;
    long long no=0;
    long double lb, ub;
    long long nlb, nub;
    int i;
    long ran[7];
    double x;
    double co[7];
    int fd;
    char resc[32];
	
    if(argc != 4)
    {
      printf("\nIncorrect no. of inputs......The correct usage is...\n");
      printf("%s lb ub temp.txt \n", argv[0]);
      exit(1);
    }

    sscanf(argv[1], "%llf", &lb);
    sscanf(argv[2], "%llf", &ub);

    nlb = (long long)(lb);
    nub = (long long)(ub);

    gettimeofday(&time1, NULL);
    stime_s =time1.tv_sec;
    stime_m=time1.tv_usec;      

    printf("\nLower bound = %lld Upper bound = %lld \n", nlb, nub);
	
    for(no=nlb; no<=nub; no++)
    {
      for(i=0; i<=6; i++)
      {
	ran[i] = random(); 
	co[i] = cos(PI*((double)ran[i]/RAND_MAX));
      }
      x = 1.0;
      for(i=0; i<=6; i++)
      {
	x = x + co[i];
	if(x <= 0.0)
	  break;
	if(x >= 5.0)
	{
	  res = res+1;
	  break;
	}
      }
    }

    gettimeofday(&time1, NULL);
    etime_s =time1.tv_sec;
    etime_m=time1.tv_usec;   
    
    etime_s = etime_s - stime_s;
    if(etime_m >= stime_m)
        etime_m = etime_m - stime_m;
    else
    {
      etime_s = etime_s - 1;
      etime_m = etime_m + 1000000 - stime_m;
    }
    printf("\n ------------------------------------------------------\n");
    printf("Total time taken:sec:%ld   millsec:%ld \n", etime_s, etime_m);
    printf("\n ------------------------------------------------------\n");      
    
    printf("Result = %lld \n", res);
    
    sprintf(resc, "%lld", res);
    fd=creat( argv[3], S_IRUSR | S_IWUSR |S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH );
    write( fd, resc, strlen(resc) );
}


