/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */


#ifndef __GCSERVER_H__
#define __GCSERVER_H__

#define CC_CC_PORT 5700
#define CC_AC_PORT 5500
#define CC_DR_PORT 5000
#define CC_UP_PORT "/tmp/CCUP"
#include "GCHost.h"


/*structure of each node of the Acceptor Table*/
typedef struct tagAcceptorTable
{
	char *ACHostName;
	char *ACLoginName;
	char *ACDaemonPath;
	int ACPID;
	
	int ACSockDesc;
	struct tagAcceptorTable *next;

}ACTABLE, *P_ACTABLE;


/*structure of each node of the Donor Table*/
typedef struct tagDonorTable
{
	char *DRHostName;
	char *DRLoginName;
	char *DRDaemonPath;
	int DRPID;

	int DRSockDesc;
	int DRStatus;
	struct tagDonorTable *next;

}DRTABLE, *P_DRTABLE;


/* Structure of each node of the Friend Cluster Coordinators Table*/
typedef struct tagFCCTable
{
	//HOST_DESCRIPTOR FriendCCHost;
	char *CCHostName;
	char *CCLoginName;
	char *CCDaemonPath;
	int CCPID;

	int CCSockDesc;
	int CCDist;
	struct tagFCCTable *next;

}FCCTABLE, *P_FCCTABLE;


typedef struct tagclusters
{
	char *Cluster;
	struct tagclusters *next;

}CLUSTERS;


/*--------------------------------------------------------------------------*/
/*structure of each node of the Client Clusters Table whom we are using */
/*
typedef struct tagCCTable
{
	//HOST_DESCRIPTOR CCHost;
	char *CCHostName;
	char *CCLoginName;
	char *CCDaemonPath;
	int CCPID;

	int CCSockDesc;
	int CCDist;
	struct tagCCTable *next;

}CCTABLE, *P_CCTABLE;
*/


/*structure of each node of the Clusters using me as a friend*/
/*
typedef struct tagFCTable
{
	//HOST_DESCRIPTOR FCHost;
	char *FCHostName;
	int FCSockDesc;
	
	struct tagFCTable *next;

}FCTABLE, *P_FCTABLE;
*/


typedef struct tagTask
{
	int TACSock;
	int TFCSock;		//Cluster ID of the cluster from where the task has come
	int TTCSock;		//Cluster ID of the cluster to which the task had been sent
	int TDRSock;
	struct tagTask *next;

}CTASK;

int usersock;
int ccsock[3];

int InitializeClusterCoordinator();
void DisplayFriends();
int AcceptMessages();
void CleanUpClusterCoordinator(int a_nSignalNumber);

/*int IsValidHost(char *, char *hostname);  */

int ProcessClusterMessage(PHOST_DESCRIPTOR a_pstHost, int sock);
int ProcessUserMessage(int sock);
int AnyDataToRead(fd_set *rfd);
int CloseHost();
int ClusterAdd(int sock);
int ClusterRead(PHOST_DESCRIPTOR l_pstHost, int sock, int l_nMessageID);
int AskACHPFInfo(int sock);
int ReceiveHPFInfo(int sock);
int AskCCHPFInfo(int sock);
int SendDonorsCount(int sock);
int SendHPF(int sock);

int ClusterAddReq(char *hname);
int ClusterAckReq(char *hname);

int InsertAcceptor(int sockd, PHOST_DESCRIPTOR);
int SearchAcceptor();
int DeleteAcceptor(int sockd);

int InsertDonor(int sockd, PHOST_DESCRIPTOR);
int SearchDonor();
int DeleteDonor(int sockd);

int InsertClient(int sockd, PHOST_DESCRIPTOR);
int DeleteClient(int sockd);

int InsertInClientList(char *hostname);
int DeleteFromClientList(char *hostname);

int InsertInFList(char *hostname);
int DeleteFromFList(char *hostname);

int InsertFriend(int sock, char *hostname);
int DeleteFriend(int sock);

int SearchCCTable(char *hostname);
int SearchFCTable(char *hostname);

int RemoveClient(char *hostname);
int RemoveFriend(char *hostname);

char *GetHostName(int sock);

int ForwardTask(int sock);
int DistributeTask(int sock);
int ReturnResultsToCluster(int sock);
int SendResultToAcceptor(int sock);

int ChangeStatusofDonor(int sock);

#endif

