/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

/* This file contains definitions for Host related data structures */

#ifndef __HOST_H__

#define __HOST_H__

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <ctype.h>
#include <strings.h>
#include <netdb.h>
#include <signal.h>

// Structure for Host Description with other details 

typedef struct tagHostDescriptor
{
	char *m_pszHostName;		//Host Name
  	char *m_pszHostLogin;		//Host Login User Name
  	char *m_pszDaemonPath;		//Path of the Daemon that is running
	  
	/* Host Socket details */
  	struct sockaddr_in *m_pstTCPHostAddress;
  	struct sockaddr_un *m_pstUNIXStreamHostAddress;
	
  	int m_nHostProcessID;		//Host Process ID
  	double m_ulHPF;  	//Horse Power Factor (HPF) of host
  
} HOST_DESCRIPTOR, *PHOST_DESCRIPTOR;


// Structure for collection of hosts in the form of Linked List 

typedef struct tagHostCollection
{
  	struct tagHostCollection *m_pstPrevious;
  	HOST_DESCRIPTOR m_stHost;             
  	struct tagHostCollection *m_pstNext;

} HOST_DESCRIPTOR_COLLECTION, *PHOST_DESCRIPTOR_COLLECTION; 


// Function to initialize a host descriptor. 

int InitializeHost(PHOST_DESCRIPTOR a_pstHostDetails, int a_nWhichAddress);

#endif
