/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#define MAX_NUM_LFS 25
#define MAX_NUM_LCS 100

#define DEBUG_ON 0

#define FALSE 0
#define TRUE 1

#define INFINITE_LOAD 2000

#define SYSPORTNO 7512
#define SYS_INIT 0
#define SYS_CHK_MSG 1   
#define GET_LOAD_FACTOR 2
#define TAKE_LOAD_FACTOR 3
#define TAKE_WORK 4
#define TAKE_RESULTS 5
#define GENERATOR_FAILED 6
#define LC_TERMINATING 7
#define LC_INIT 8
#define LC_CHK_MSG 9
#define TERMINATE 10
#define WANT_RESULTS 11
#define USER_TERMINATING 12
#define GET_FILE 13
#define TAKE_FILE 14
#define GIVE_ARGS 15
#define TAKE_ARGS 16
#define FILE_REQUIRED 20

#define USER_INIT 17
#define RESULTS_AVAILABLE 18
#define RESULTS_NOT_AVAILABLE -1
#define RESULTS_FAILED -2
#define CHECK_RESULTS 19

#define SUNDOMAIN 1001
#define SPARCDOMAIN 1002
#define INTELDOMAIN 1003
#define IBMDOMAIN 1004
/* The following are part of the resultptr 
   (needed to return NULL to user in obtain_result call) */

#define RESULTS_VALID 15
#define RESULTS_INVALID 16


typedef struct {
  int type1;
  int type2;
  char loadFactor[10];
  int numLFreq;
  int index;              /* Local Descriptor Index */
  int follMsgSize;
  int follArgSize;
  int resultSize;
  int srcLocal;
  int destLocal;
  int srcPid;
  int destPid;
  int srcSeqNo;
} Message;

typedef struct res {   
  int valid;
  char* resultPtr;
  int resultSize;
  int srcLocal;    /* index */
  int destLocal;   /* index */
  int srcPid;
  int destPid;
  int srcSeqNo;
} ResultNode;

typedef struct{
  char loadFactor[10];
  int index;              /* Local Descriptor Index */
} LFnode;

typedef struct{
  LFnode LFinfo[MAX_NUM_LFS];
  int number;            /* requested/returned */
} LFmessage;

typedef struct {
  char *args;
  int argSize;
  int resultSize;
} ArgStruct;

typedef struct {
  char mcName[50];
  int  CPUid;
  int GROUPid;
  float loadFactor;
  int valid;
  int sockfd;
} LocalDescriptor;

typedef struct {
  char mcName[50];
  char arch[50];
  char compilestr[300];
} ConfigDescriptor;







