/* Copyright (C) DOS Lab, Dept. of CS & E, IIT Madras.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include <stdio.h>

int get_initial_rib_number(void)
{
  FILE *fp_global_rib_number;
  int fd_global_rib_number;
  int number_of_ribs;
	
  if((fd_global_rib_number = open("global.number.mutex", O_RDWR)) == -1)
    {
      printf("error opening file global.number.mutex\n");
      exit(1);
    }
	
  if((fp_global_rib_number = fopen("global.number", "r")) == NULL)
    {
      printf("error opening file global.number\n");
      exit(1);
    }

  lseek(fd_global_rib_number,0,SEEK_SET);
  if(lockf(fd_global_rib_number,F_LOCK,0) == -1)
    {
      printf("error locking file global.number.mutex\n");
      perror("lock :");
      exit(1);
    }

  fseek(fp_global_rib_number,0,SEEK_SET);
  fscanf(fp_global_rib_number,"%d",&number_of_ribs);

  lseek(fd_global_rib_number,0,SEEK_SET);
  if(lockf(fd_global_rib_number,F_ULOCK,0) == -1)
    {
      printf("error unlocking file global.number.mutex\n");
      perror("unlock :");
      exit(1);
    }
	
  fclose(fp_global_rib_number);
  close(fd_global_rib_number);
  return(number_of_ribs);
}
