/* This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include <stdio.h>

typedef struct {
  double element[10][10];
  int rows,cols;
} Matrix;

void Initialize(Matrix *m) 
{
  int i,j;

  for(i =0;i < m -> rows;i++) {
    for(j = 0;j < m->cols;j++) {
      m->element[i][j] = (double)(i+j)/(double)(i + 2 * j + 1);
    }
  }
}

char *multiply(char *m)
{
  Matrix *mat;
  int i,j,k;
  Matrix *product;

  product = (Matrix *)malloc(sizeof(Matrix));
  if(product == NULL) {
    printf("No space to allocate for matrix\n");
    exit(1);
  }
  mat = (Matrix *)m;
  product->rows = mat[0].rows;
  product->cols = mat[1].cols;
  for(i = 0;i < mat[0].rows;i++) {
    for(j = 0;j < mat[1].cols;j++) {
      product->element[i][j] = 0;
      for(k = 0;k < mat[0].cols;k++) 
	product->element[i][j] += mat[0].element[i][k] * mat[1].element[k][j];
    }
  }

  return (char *)(product);
}




