/* This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

/*extern "C" {
#include <stdio.h>

void free(void *);
void *malloc(unsigned int);
void bcopy (void *, void *, int);
void bzero(void *, int);
int read(int, char *, int);
int write(int, char *, int);

int close(int);
struct hostent *gethostbyname(const char *);
int gethostname (char *,int);
char *strcat(char *,char *);
int getpid(void);
int sleep(int);
}
*/
#include <unistd.h>
#ifdef SPARC
extern "C" {
#include <stdio.h>

void bcopy(void *,void *,int);
int gethostname(char *,int);
}
#else
#include <strings.h>
#endif
#include <stdlib.h>

typedef struct datanode {
  char *item;
  int itemSize;
  struct datanode *next;
} Item;

struct datapack {
  char *data;
  int size;
  Item *link;	
};


/**********************************************************************
Routines to pack an unpack data items into one single contiguous memory unit 
***********************************************************************/

struct datapack open_datapack (void) 
{ 
  struct datapack dp;
 
  dp.data = NULL;
  dp.size = 0;
  dp.link = NULL;
  
  return (dp);
}


void flush_datapack (struct datapack *dpptr)
{
  Item *tmp;

  free (dpptr->data);
  dpptr->data = NULL;
  dpptr->size = 0;
  dpptr->link = NULL;  
}

void new_insert_datapack (struct datapack *pack,char *item, int size)
{
  Item *inew;
  Item *tmp;

  inew = (Item *) malloc (sizeof (Item) );
  inew->item = item;
  inew->itemSize = size;
  inew->next = NULL;
	
  if (pack->link == NULL) pack->link = inew;
  else {
    tmp=pack->link;
    while (tmp->next != NULL) tmp = tmp->next;
    tmp-> next = inew;
  }

  pack->size = pack->size + size; /* cumulative size */	
}

void close_datapack (struct datapack *pack)
{
  Item *tmp, *x;
  int currentSize = 0;

  pack-> data = (char *) malloc (pack->size * sizeof (char) );

  tmp = pack->link;

  while (tmp != NULL) {
    x = tmp;
    bcopy(tmp->item,&(pack->data[currentSize]),tmp->itemSize);
    currentSize = currentSize + tmp->itemSize;
    tmp = tmp->next ;
  }
  
  pack->link = NULL ;
}

void insert_datapack (struct datapack *pack,char *data,int size)
{ 
  int newsize;
  char *newdata;

  if (pack->size == 0) {
    pack->data = (char *) malloc (size);
    bcopy (data,pack->data,  size);
    pack->size = size;
  } else {
    newsize = pack->size + size;
    newdata = (char *) malloc (newsize);
    bcopy (pack->data,newdata,  pack->size);
    free (pack->data);
    bcopy (data,&(newdata[pack->size]),  size);
    pack->size = newsize;
    pack->data = newdata;	
  }
}

void get_datapack (struct datapack *pack,char *data,int size)
{
  char *tmp;
	
  bcopy (pack->data, data, size);
  
  if ( (pack->size - size) != 0 ) {
    tmp = (char *) malloc (pack->size - size);
    bcopy (&(pack->data [size]),tmp, pack->size - size);
    free (pack->data);
    pack->data = tmp;
    pack->size -= size;
  } else {
    free (pack->data);
    pack->data = NULL;
    pack->size = 0;
  }
}
