/* This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#ifdef SPARC
#include <string.h>
#else 
#include <strings.h>
#endif
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>

int  read_ready_test (int sock, long sec, long microsec)

/*  only for 1 socket at a time */
/* can be modified for multiple sockets, but then it becomes */
/* more or less like what is provided by Unix */
{
  fd_set readfds;
  int first_call = 1;
  struct timeval timeout;
  int ready;

  FD_ZERO (&readfds);
  timeout.tv_sec=sec;
  timeout.tv_usec =microsec;
  
  FD_SET (sock, &readfds);
  
  ready = select(getdtablesize()+1, &readfds, (fd_set *)0,(fd_set *)0, &timeout);
  
  FD_CLR (sock, &readfds);
  
  return (ready);
}		

