/* This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#include"add.c"
#include"sub.c"
#include <rpc/rpc.h>

int main()
{
  int i,a[3],b[3],c[3],d[3];
  XDR p[3];
  char buf[3][100];
  char *temp;
  int tag[6];
  LFmessage lf;
  struct datapack dp;

  a[0] = 0;
  a[1] = 1;
  a[2] = 2;
  b[0] = 3;
  b[1] = 4;
  b[2] = 5;
  initialize_ARC();
  lf = get_load_factor(3);
  printf("Number of machines available : %d\n", lf.number);

  for(i = 0;i < 3;i++) {
    xdrmem_create(&p[i],buf[i],100,XDR_ENCODE);
    xdr_int(&p[i],&a[i]);
    xdr_int(&p[i],&b[i]);
  }

  if(lf.number < 3) {
    for(i = 0;i < 3;i++) {
      ARC_function_call(add,10, 3,buf[i], 100, lf.LFinfo[0].index,tag[i],20);
      ARC_function_call(sub,10, 3,buf[i], 100, lf.LFinfo[0].index,tag[i+3],20);
    }
  } else {
    for(i = 0;i < 3;i++) {
      ARC_function_call(add,10, 3,buf[i], 100, lf.LFinfo[i].index,tag[i],20);
      ARC_function_call(sub,10, 3,buf[i], 100, lf.LFinfo[i].index,tag[i+3],20);
    }
  }
  
  for(i = 0;i < 3;i++) {
    temp = (obtain_result(tag[i]));
    if(temp == NULL) {
      printf("The program %d is taking more time than timeout.\n",i);
    } else {
      xdrmem_create(&p[i],temp,20,XDR_DECODE);
      xdr_int(&p[i],&c[i]);
    }
    
    temp = (obtain_result(tag[i+3]));
    if(temp == NULL) {
      printf("The program %d is taking more time than timeout.\n",i+3);
    } else {
      xdrmem_create(&p[i],temp,20,XDR_DECODE);
      xdr_int(&p[i],&d[i]);
    }
  }

  printf("Result for %d machines: \n",lf.number);
  printf("Sum Array is \t\t%d\t%d\t%d\n",c[0],c[1],c[2]);
  printf("Difference array is\t%d\t%d\t%d\n",d[0],d[1],d[2]);
  close_ARC();
  return 1;
}
