/* This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to Prof. D. Janakiram, 
DOS Lab, Department of CS & E, Indian Institute of Technology Madras, 
Chennai - 600036, India. Alternatively, you can send a mail to 
d.janakiram@cs.iitm.ernet.in. */

#define MAX_FUNC_NAME_LEN 254
#define MAX_COMMON_SOCKET_LEN 50

#define MAX_STORABLE_WORK 500

#define WORK_IN_PROGRESS 200
#define WORK_FAILED 201
#define WORK_DONE 202

#define WAIT_WITHIN_TIMEOUT 4
#define ABSOLUTE_WAIT_TIME 60

typedef struct {
  int sequence_no;
  char func_name[MAX_FUNC_NAME_LEN + 1];
  struct datapack *dpptr;
  int result_size;
  int timeout;
  int start_time;                       /* to ease check for timeout */
  int max_retries;
  int retries_made;
  int machine_id;
  int status;
} work_queue_t;

